Index: src/main/java/mk/ukim/finki/busngo/service/AvtobusService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/AvtobusService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/AvtobusService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,12 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Avtobus;
+import mk.ukim.finki.busngo.repository.AvtobusRepository;
+
+import java.util.List;
+
+public interface AvtobusService {
+    List<Avtobus> findAll();
+
+    Avtobus findById(String aRegistracija);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/BiletService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/BiletService.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/service/BiletService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -2,4 +2,5 @@
 
 import mk.ukim.finki.busngo.model.entities.Bilet;
+import mk.ukim.finki.busngo.model.entities.Patnik;
 import mk.ukim.finki.busngo.model.enums.BILET_STATUS;
 
@@ -13,3 +14,13 @@
 
     Bilet buy(Long tipbilet, LocalDateTime now, BILET_STATUS biletStatus, String name);
+
+    List<Bilet> findAllByPatnikEmail(String email);
+    Bilet findBybIdAndPatnikEmail(Long bId, String email);
+
+    Bilet activate(Long bId);
+    Bilet findById(Long bId);
+    Bilet finish(Long bId);
+
+    boolean checkExpiration(Long bId);
+//    void encode();
 }
Index: src/main/java/mk/ukim/finki/busngo/service/InstancaNaLinijaService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/InstancaNaLinijaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/InstancaNaLinijaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,17 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Instancanalinija;
+
+import javax.swing.event.ListDataEvent;
+import java.time.LocalDateTime;
+import java.util.List;
+
+public interface InstancaNaLinijaService {
+    List<Instancanalinija> findAll();
+    Instancanalinija findById(Long inlId);
+    Instancanalinija start(Long liId, String a_registracija, String email);
+    Instancanalinija end(Long inlId);
+    List<Instancanalinija> findAllActive();
+
+    List<Instancanalinija> findByPnlId(Long pnlId);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/KaznaService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/KaznaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/KaznaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,10 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Kazna;
+
+import java.util.List;
+
+public interface KaznaService {
+    List<Kazna> findAll();
+    List<Kazna> findAllByKontrolaId(Long kontrolaId);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/KaznaZaNeregistriranService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/KaznaZaNeregistriranService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/KaznaZaNeregistriranService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,20 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Kaznazaneregistriran;
+import mk.ukim.finki.busngo.model.entities.Kaznazaregistriran;
+import org.springframework.security.core.Authentication;
+import org.springframework.web.bind.annotation.RequestParam;
+
+import java.util.List;
+
+public interface KaznaZaNeregistriranService {
+    List<Kaznazaneregistriran> findAll();
+    Kaznazaneregistriran findById(Long id);
+    Kaznazaneregistriran create(Long kontrolaId,
+                                 String dokument,
+                                Double iznos,
+                                 String telefon,
+                                 String ime,
+                                 String adresa,
+                                String email);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/KaznaZaRegistriranService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/KaznaZaRegistriranService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/KaznaZaRegistriranService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,12 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Kaznazaregistriran;
+import mk.ukim.finki.busngo.model.exceptions.UserShouldNotBeTicketedException;
+
+import java.util.List;
+
+public interface KaznaZaRegistriranService {
+    List<Kaznazaregistriran> findAllByPatnik(String email);
+
+    Kaznazaregistriran create(Long kontrolaId, String dokument, Double iznos, Long patnik, String email) throws UserShouldNotBeTicketedException;
+}
Index: src/main/java/mk/ukim/finki/busngo/service/KondukterService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/KondukterService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/KondukterService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,10 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Kondukter;
+
+import java.util.List;
+
+public interface KondukterService {
+    List<Kondukter> findAll();
+    Kondukter findByEmail(String email);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/KontrolaService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/KontrolaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/KontrolaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,14 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Kontroli;
+
+import java.util.List;
+
+public interface KontrolaService {
+    List<Kontroli> findAll();
+    Kontroli create(Long inlId, String email);
+
+    Kontroli findById(Long kontrolaId);
+
+    List<Kontroli> findAllByInl(Long inlId);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/LinijaService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/LinijaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/LinijaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,11 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Linija;
+
+import java.util.List;
+
+public interface LinijaService {
+    List<Linija> findAll();
+
+    Linija findById(Long liId);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/PatnikService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/PatnikService.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/service/PatnikService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -2,4 +2,5 @@
 
 import mk.ukim.finki.busngo.model.entities.Bilet;
+import mk.ukim.finki.busngo.model.entities.Korisnik;
 import mk.ukim.finki.busngo.model.entities.Patnik;
 
@@ -9,4 +10,7 @@
     List<Patnik> listAll();
     Patnik findById(Long id);
+    Patnik loadUserByEmail(String email);
+
+    Patnik save(Korisnik korisnik);
 
 }
Index: src/main/java/mk/ukim/finki/busngo/service/PostojkaNaLinijaService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/PostojkaNaLinijaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/PostojkaNaLinijaService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,12 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Postojkanalinija;
+
+import java.util.List;
+
+public interface PostojkaNaLinijaService {
+    List<Postojkanalinija> findAll();
+    Postojkanalinija findById(Long id);
+    List<Postojkanalinija> findByLinija(Long liId);
+    List<Postojkanalinija> findByLinijaAfterRedenBroj(Long liId, Short redenBroj);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/VozacService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/VozacService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/VozacService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,11 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Vozac;
+import mk.ukim.finki.busngo.repository.VozacRepository;
+
+import java.util.List;
+
+public interface VozacService {
+    List<Vozac> findAll();
+    Vozac findByEmail(String email);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/VozenjeService.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/VozenjeService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/VozenjeService.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,12 @@
+package mk.ukim.finki.busngo.service;
+
+import mk.ukim.finki.busngo.model.entities.Vozenje;
+
+import java.util.List;
+
+public interface VozenjeService {
+    List<Vozenje> findVozenjaByPatnik(String email);
+    Vozenje start(String email, Long bId, Long pnlId, Long inlId);
+    Vozenje end(Long vozenjeId, Long pnlId);
+    Vozenje findById(Long id);
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/AuthServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/AuthServiceImpl.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/AuthServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -2,20 +2,22 @@
 
 import mk.ukim.finki.busngo.model.entities.Korisnik;
+import mk.ukim.finki.busngo.model.entities.Patnik;
 import mk.ukim.finki.busngo.model.exceptions.InvalidCredentialsException;
 import mk.ukim.finki.busngo.model.exceptions.UserAlreadyExistsException;
 import mk.ukim.finki.busngo.repository.KorisnikRepository;
+import mk.ukim.finki.busngo.repository.PatnikRepository;
 import mk.ukim.finki.busngo.service.AuthService;
 import org.springframework.security.crypto.password.PasswordEncoder;
 import org.springframework.stereotype.Service;
 
-import java.util.List;
-
 @Service
 public class AuthServiceImpl implements AuthService {
     private final KorisnikRepository korisnikRepository;
+    private final PatnikRepository patnikRepository;
     private final PasswordEncoder passwordEncoder;
 
-    public AuthServiceImpl(KorisnikRepository korisnikRepository, PasswordEncoder passwordEncoder) {
+    public AuthServiceImpl(KorisnikRepository korisnikRepository, PatnikRepository patnikRepository, PasswordEncoder passwordEncoder) {
         this.korisnikRepository = korisnikRepository;
+        this.patnikRepository = patnikRepository;
         this.passwordEncoder = passwordEncoder;
     }
@@ -29,5 +31,5 @@
 
     @Override
-    public Korisnik register(String ime, String email, String password, String confirmPassword, String address, String telefon) {
+    public Korisnik registerPatnik(String ime, String email, String password, String confirmPassword, String address, String telefon) {
         if (email == null || password == null || email.isEmpty() || password.isEmpty()) {
             throw new InvalidCredentialsException();
@@ -42,5 +44,5 @@
         }
 
-        Korisnik korisnik = new Korisnik();
+        Patnik korisnik = new Patnik();
         korisnik.setKIme(ime);
         korisnik.setKAdresa(address);
@@ -50,5 +52,6 @@
         korisnik.setKIsAdmin(false);
 
-        return korisnikRepository.save(korisnik);
+
+        return patnikRepository.save(korisnik);
     }
 
Index: src/main/java/mk/ukim/finki/busngo/service/impl/AvtobusServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/AvtobusServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/AvtobusServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,28 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.Avtobus;
+import mk.ukim.finki.busngo.model.exceptions.InvalidAvtobusRegistracijaException;
+import mk.ukim.finki.busngo.repository.AvtobusRepository;
+import mk.ukim.finki.busngo.service.AvtobusService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+
+@Service
+public class AvtobusServiceImpl implements AvtobusService {
+    private final AvtobusRepository avtobusRepository;
+
+    public AvtobusServiceImpl(AvtobusRepository avtobusRepository) {
+        this.avtobusRepository = avtobusRepository;
+    }
+
+    @Override
+    public List<Avtobus> findAll() {
+        return avtobusRepository.findAll();
+    }
+
+    @Override
+    public Avtobus findById(String aRegistracija) {
+        return avtobusRepository.findByARegistracija(aRegistracija).orElseThrow(InvalidAvtobusRegistracijaException::new);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/BiletServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/BiletServiceImpl.java	(revision b101b69e1e4156497c29fa60f501b18007efeab7)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/BiletServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -3,12 +3,16 @@
 import mk.ukim.finki.busngo.model.entities.Bilet;
 import mk.ukim.finki.busngo.model.entities.Korisnik;
+import mk.ukim.finki.busngo.model.entities.Patnik;
 import mk.ukim.finki.busngo.model.entities.Tipbilet;
 import mk.ukim.finki.busngo.model.enums.BILET_STATUS;
+import mk.ukim.finki.busngo.model.exceptions.InvalidBiletIdException;
 import mk.ukim.finki.busngo.model.exceptions.InvalidTipBiletIdException;
 import mk.ukim.finki.busngo.repository.BiletRepository;
+import mk.ukim.finki.busngo.repository.KorisnikRepository;
 import mk.ukim.finki.busngo.repository.TipBIletRepository;
 import mk.ukim.finki.busngo.service.BiletService;
 import mk.ukim.finki.busngo.service.KorisnikService;
 import mk.ukim.finki.busngo.service.PatnikService;
+import org.springframework.security.crypto.password.PasswordEncoder;
 import org.springframework.stereotype.Service;
 
@@ -24,10 +28,14 @@
     private final TipBIletRepository tipBIletRepository;
     private final PatnikService patnikService;
+    private final PasswordEncoder passwordEncoder;
+    private final KorisnikRepository korisnikRepository;
 
-    public BiletServiceImpl(BiletRepository biletRepository, KorisnikService korisnikService, TipBIletRepository tipBIletRepository, PatnikService patnikService) {
+    public BiletServiceImpl(BiletRepository biletRepository, KorisnikService korisnikService, TipBIletRepository tipBIletRepository, PatnikService patnikService, PasswordEncoder passwordEncoder, KorisnikRepository korisnikRepository) {
         this.biletRepository = biletRepository;
         this.korisnikService = korisnikService;
         this.tipBIletRepository = tipBIletRepository;
         this.patnikService = patnikService;
+        this.passwordEncoder = passwordEncoder;
+        this.korisnikRepository = korisnikRepository;
     }
 
@@ -39,6 +47,6 @@
     @Override
     public List<Bilet> findAllByPatnikId(Long id) {
-        Korisnik korisnik = korisnikService.findById(id);
-        return new ArrayList<>();
+        Patnik patnik = patnikService.findById(id);
+        return patnik.getBiletsByKId();
     }
 
@@ -52,5 +60,5 @@
     public Bilet buy(Long tipbilet, LocalDateTime now, BILET_STATUS biletStatus, String name) {
         Tipbilet tipbilet1 = tipBIletRepository.findById(tipbilet).orElseThrow(InvalidTipBiletIdException::new);
-        Korisnik korisnik = korisnikService.loadUserByEmail(name);
+        Patnik korisnik = patnikService.loadUserByEmail(name);
         Bilet bilet = new Bilet();
         bilet.setBStatus(biletStatus);
@@ -60,3 +68,58 @@
         return biletRepository.save(bilet);
     }
+
+    @Override
+    public List<Bilet> findAllByPatnikEmail(String email) {
+        Patnik patnik = patnikService.loadUserByEmail(email);
+        return patnik.getBiletsByKId();
+    }
+
+    @Override
+    public Bilet findBybIdAndPatnikEmail(Long bId, String email) {
+        Patnik patnik = patnikService.loadUserByEmail(email);
+        return biletRepository.findByBIdAndAndKorisnikByPatnikKId(bId, patnik).orElseThrow(InvalidBiletIdException::new);
+    }
+
+    @Override
+    public Bilet activate(Long bId) {
+        Bilet bilet = this.findById(bId);
+        bilet.setBStatus(BILET_STATUS.ACTIVE);
+        return biletRepository.save(bilet);
+    }
+
+    @Override
+    public Bilet findById(Long bId) {
+        return biletRepository.findById(bId).orElseThrow(RuntimeException::new);
+    }
+
+    @Override
+    public Bilet finish(Long bId) {
+        Bilet bilet = this.findById(bId);
+        bilet.setBStatus(BILET_STATUS.EXPIRED);
+        return biletRepository.save(bilet);
+    }
+
+    @Override
+    public boolean checkExpiration(Long bId) {
+        Bilet bilet = this.findById(bId);
+        LocalDateTime timeBought = bilet.getBDatumNaKupuvanje().toLocalDateTime();
+
+        if(timeBought.plusSeconds(bilet.getTipbiletByTbId().getTbTrajnost()).isBefore(LocalDateTime.now())){
+            bilet.setBStatus(BILET_STATUS.EXPIRED);
+            biletRepository.save(bilet);
+            return true;
+        }
+
+        return false;
+    }
+
+//    @Override
+//    public void encode(){
+//        List<Korisnik> all = korisnikRepository.findAll();
+//        all.forEach(p -> p.setKLozinka(passwordEncoder.encode(p.getKLozinka())));
+//        korisnikRepository.saveAll(all);
+//        System.out.println("DONE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
+//    }
+
+
 }
Index: src/main/java/mk/ukim/finki/busngo/service/impl/InstancaNaLinijaServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/InstancaNaLinijaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/InstancaNaLinijaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,71 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.*;
+import mk.ukim.finki.busngo.model.exceptions.InvalidInstancaNaLinijaIdException;
+import mk.ukim.finki.busngo.repository.InstancaNaLinijaRepository;
+import mk.ukim.finki.busngo.service.*;
+import org.springframework.stereotype.Service;
+
+import java.sql.Timestamp;
+import java.time.LocalDateTime;
+import java.util.List;
+
+@Service
+public class InstancaNaLinijaServiceImpl implements InstancaNaLinijaService{
+    private final InstancaNaLinijaRepository instancaNaLinijaRepository;
+    private final VozacService vozacService;
+    private final AvtobusService avtobusService;
+    private final LinijaService linijaService;
+    private final PostojkaNaLinijaService postojkaNaLinijaService;
+
+    public InstancaNaLinijaServiceImpl(InstancaNaLinijaRepository instancaNaLinijaRepository, VozacService vozacService, AvtobusService avtobusService, LinijaService linijaService, PostojkaNaLinijaService postojkaNaLinijaService) {
+        this.instancaNaLinijaRepository = instancaNaLinijaRepository;
+        this.vozacService = vozacService;
+        this.avtobusService = avtobusService;
+        this.linijaService = linijaService;
+        this.postojkaNaLinijaService = postojkaNaLinijaService;
+    }
+
+    @Override
+    public List<Instancanalinija> findAll() {
+        return instancaNaLinijaRepository.findAll();
+    }
+
+    @Override
+    public Instancanalinija findById(Long inlId) {
+        return instancaNaLinijaRepository.findById(inlId).orElseThrow(InvalidInstancaNaLinijaIdException::new);
+    }
+
+    @Override
+    public Instancanalinija start(Long liId, String a_registracija, String email) {
+        Linija linija = linijaService.findById(liId);
+        Avtobus avtobus = avtobusService.findById(a_registracija);
+        Vozac vozac = vozacService.findByEmail(email);
+        Instancanalinija instancanalinija = new Instancanalinija();
+        instancanalinija.setLinijaByLiId(linija);
+        instancanalinija.setAvtobusByARegistracija(avtobus);
+        instancanalinija.setKorisnikByVozacKId(vozac);
+        instancanalinija.setInlDatumStart(Timestamp.valueOf(LocalDateTime.now()));
+
+        return instancaNaLinijaRepository.save(instancanalinija);
+    }
+
+    @Override
+    public Instancanalinija end(Long inlId) {
+        Instancanalinija instancanalinija = this.findById(inlId);
+        instancanalinija.setInlDatumEnd(Timestamp.valueOf(LocalDateTime.now()));
+        return instancaNaLinijaRepository.save(instancanalinija);
+    }
+
+    @Override
+    public List<Instancanalinija> findAllActive() {
+        return instancaNaLinijaRepository.findAllByInlDatumEndIsNull();
+    }
+
+    @Override
+    public List<Instancanalinija> findByPnlId(Long pnlId) {
+        Postojkanalinija postojkanalinija = postojkaNaLinijaService.findById(pnlId);
+        Linija linijaByLiId = postojkanalinija.getLinijaByLiId();
+        return instancaNaLinijaRepository.findAllByLinijaByLiIdAndInlDatumEndIsNull(linijaByLiId);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/KaznaServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/KaznaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/KaznaServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,32 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.Kazna;
+import mk.ukim.finki.busngo.model.entities.Kontroli;
+import mk.ukim.finki.busngo.repository.KaznaRepository;
+import mk.ukim.finki.busngo.service.KaznaService;
+import mk.ukim.finki.busngo.service.KontrolaService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+
+@Service
+public class KaznaServiceImpl implements KaznaService {
+    private final KaznaRepository kaznaRepository;
+    private final KontrolaService kontrolaService;
+
+    public KaznaServiceImpl(KaznaRepository kaznaRepository, KontrolaService kontrolaService) {
+        this.kaznaRepository = kaznaRepository;
+        this.kontrolaService = kontrolaService;
+    }
+
+    @Override
+    public List<Kazna> findAll() {
+        return kaznaRepository.findAll();
+    }
+
+    @Override
+    public List<Kazna> findAllByKontrolaId(Long kontrolaId) {
+        Kontroli kontroli = kontrolaService.findById(kontrolaId);
+        return kaznaRepository.findAllByKontroliByKontrolaId(kontroli);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/KaznaZaNeregistriranServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/KaznaZaNeregistriranServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/KaznaZaNeregistriranServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,53 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.Kaznazaneregistriran;
+import mk.ukim.finki.busngo.model.entities.Kondukter;
+import mk.ukim.finki.busngo.model.entities.Kontroli;
+import mk.ukim.finki.busngo.repository.KaznaZaNeregistriranRepository;
+import mk.ukim.finki.busngo.service.KaznaZaNeregistriranService;
+import mk.ukim.finki.busngo.service.KondukterService;
+import mk.ukim.finki.busngo.service.KontrolaService;
+import org.springframework.stereotype.Service;
+
+import java.sql.Timestamp;
+import java.time.LocalDateTime;
+import java.util.List;
+@Service
+public class KaznaZaNeregistriranServiceImpl implements KaznaZaNeregistriranService {
+    private final KaznaZaNeregistriranRepository kaznaZaNeregistriranRepository;
+    private final KontrolaService kontrolaService;
+    private final KondukterService kondukterService;
+
+    public KaznaZaNeregistriranServiceImpl(KaznaZaNeregistriranRepository kaznaZaNeregistriranRepository, KontrolaService kontrolaService, KondukterService kondukterService) {
+        this.kaznaZaNeregistriranRepository = kaznaZaNeregistriranRepository;
+        this.kontrolaService = kontrolaService;
+        this.kondukterService = kondukterService;
+    }
+
+    @Override
+    public List<Kaznazaneregistriran> findAll() {
+        return kaznaZaNeregistriranRepository.findAll();
+    }
+
+    @Override
+    public Kaznazaneregistriran findById(Long id) {
+        return kaznaZaNeregistriranRepository.findById(id).orElseThrow(RuntimeException::new);
+    }
+
+    @Override
+    public Kaznazaneregistriran create(Long kontrolaId, String dokument, Double iznos, String telefon, String ime, String adresa, String email) {
+        Kondukter byEmail = kondukterService.findByEmail(email);
+        Kontroli kontroli = kontrolaService.findById(kontrolaId);
+        Kaznazaneregistriran kaznazaneregistriran = new Kaznazaneregistriran();
+        kaznazaneregistriran.setKznAdresa(adresa);
+        kaznazaneregistriran.setKznIme(ime);
+        kaznazaneregistriran.setKznTelefon(telefon);
+        kaznazaneregistriran.setKzDatum(Timestamp.valueOf(LocalDateTime.now()));
+        kaznazaneregistriran.setKontroliByKontrolaId(kontroli);
+        kaznazaneregistriran.setKorisnikByKondukterKId(byEmail);
+        kaznazaneregistriran.setKzIznos(iznos);
+        kaznazaneregistriran.setKzDokument(dokument);
+        kaznazaneregistriran.setKzPlateno(false);
+        return kaznaZaNeregistriranRepository.save(kaznazaneregistriran);
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/KaznaZaRegistriranServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/KaznaZaRegistriranServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/KaznaZaRegistriranServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,61 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.*;
+import mk.ukim.finki.busngo.model.exceptions.UserShouldNotBeTicketedException;
+import mk.ukim.finki.busngo.repository.KaznaZaRegistriranRepository;
+import mk.ukim.finki.busngo.service.KaznaZaRegistriranService;
+import mk.ukim.finki.busngo.service.KondukterService;
+import mk.ukim.finki.busngo.service.KontrolaService;
+import mk.ukim.finki.busngo.service.PatnikService;
+import org.springframework.stereotype.Service;
+
+import java.sql.Timestamp;
+import java.time.LocalDateTime;
+import java.util.List;
+import java.util.stream.Collectors;
+
+@Service
+public class KaznaZaRegistriranServiceImpl implements KaznaZaRegistriranService {
+    private final PatnikService patnikService;
+    private final KaznaZaRegistriranRepository kaznaZaRegistriranRepository;
+    private final KontrolaService kontrolaService;
+    private final KondukterService kondukterService;
+
+    public KaznaZaRegistriranServiceImpl(PatnikService patnikService, KaznaZaRegistriranRepository kaznaZaRegistriranRepository, KontrolaService kontrolaService, KondukterService kondukterService) {
+        this.patnikService = patnikService;
+        this.kaznaZaRegistriranRepository = kaznaZaRegistriranRepository;
+        this.kontrolaService = kontrolaService;
+        this.kondukterService = kondukterService;
+    }
+
+    @Override
+    public List<Kaznazaregistriran> findAllByPatnik(String email) {
+        Patnik patnik = patnikService.loadUserByEmail(email);
+        return kaznaZaRegistriranRepository.findAllByKorisnikByPatnikKId(patnik);
+    }
+
+    @Override
+    public Kaznazaregistriran create(Long kontrolaId, String dokument, Double iznos, Long patnik, String email) {
+        Kontroli kontroli = kontrolaService.findById(kontrolaId);
+        Kondukter kondukter = kondukterService.findByEmail(email);
+        Patnik patnik1 = patnikService.findById(patnik);
+        Kaznazaregistriran kaznazaregistriran = new Kaznazaregistriran();
+        kaznazaregistriran.setKzDatum(Timestamp.valueOf(LocalDateTime.now()));
+        kaznazaregistriran.setKzDokument(dokument);
+        kaznazaregistriran.setKzIznos(iznos);
+        kaznazaregistriran.setKzPlateno(false);
+        kaznazaregistriran.setKontroliByKontrolaId(kontroli);
+        kaznazaregistriran.setKorisnikByPatnikKId(patnik1);
+        kaznazaregistriran.setKorisnikByKondukterKId(kondukter);
+        List<Vozenje> vozenjeList = patnik1.getVozenjesByKId().stream()
+                .filter(v -> v.getInstancanalinijaByInlId().getInlId().equals(kontroli.getInstancanalinijaByInlId().getInlId()))
+                .toList();
+        if(vozenjeList.isEmpty())
+            return kaznaZaRegistriranRepository.save(kaznazaregistriran);
+
+        throw new UserShouldNotBeTicketedException(String.format("Patnik with id: %d and email: %s has valid vozenje for the %d instance!",
+                patnik1.getKId(),
+                patnik1.getKEmail(),
+                kontroli.getInstancanalinijaByInlId().getInlId()));
+    }
+}
Index: src/main/java/mk/ukim/finki/busngo/service/impl/KondukterServiceImpl.java
===================================================================
--- src/main/java/mk/ukim/finki/busngo/service/impl/KondukterServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
+++ src/main/java/mk/ukim/finki/busngo/service/impl/KondukterServiceImpl.java	(revision bde8b1381c72e66b4414f8010493f3f189b15c03)
@@ -0,0 +1,28 @@
+package mk.ukim.finki.busngo.service.impl;
+
+import mk.ukim.finki.busngo.model.entities.Kondukter;
+import mk.ukim.finki.busngo.model.exceptions.InvalidUserId;
+import mk.ukim.finki.busngo.repository.KondukterRepository;
+import mk.ukim.finki.busngo.service.KondukterService;
+import org.springframework.stereotype.Service;
+
+import java.util.List;
+
+@Service
+public class KondukterServiceImpl implements KondukterService {
+    private final KondukterRepository kondukterRepository;
+
+    public KondukterServiceImpl(KondukterRepository kondukterRepository) {
+        this.kondukterRepository = kondukterRepository;
+    }
+
+    @Override
+    public List<Kondukter> findAll() {
+        return kondukterRepository.findAll();
+    }
+
+    @Override
+    public Kondukter findByEmail(String email) {
+        return kondukterRepository.findByKEmail(email).orElseThrow(InvalidUserId::new);
+    }
+}
